Attribute VB_Name = "asm_GrayScale"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!


Option Explicit

' asmScale
'
' CALL asmScale(ptr:lpAsmBmpPara, [rf:redfct], _
'              [gf:greenfct], [bf:bluefct])
'
' IN:   lng:ptr Points to asmBmpPara-structure
'       lng:rf  red   factor     (default = 71)
'       lng:gf  green factor     (default = 707)
'       bol:bf  blue  factor     (default = 222)
'
' OUT:  bol     success
'

Function asmScale(lpAsmBmpPara As Long, _
    Optional rf As Long = 71, _
    Optional gf As Long = 707, _
    Optional bf As Long = 222) As Boolean
    
    Static asm(19) As Long
    
    If asm(0) = 0 Then
        asm(0) = &HEC8B5590
        asm(1) = &H68575653
        asm(2) = &H3E8
        asm(3) = &H8B085D8B
        asm(4) = &H7B8B1473
        asm(5) = &H1C4B8B2C
        asm(6) = &H204BAF0F
        asm(7) = &H8BDB33AD
        asm(8) = &H8AD48AD3
        asm(9) = &H55AF0FD8
        asm(10) = &H5DAF0F10
        asm(11) = &HC1DA030C
        asm(12) = &H65F710E8
        asm(13) = &HF7C30314
        asm(14) = &HE08AF075
        asm(15) = &H8A08E0C1
        asm(16) = &HD8E2ABC4
        asm(17) = &HC01B58F9
        asm(18) = &H5D5B5E5F
        asm(19) = &H10C2
    End If
    
    ' ************************************************************
    
    asmScale = CallWindowProc(asm(0), lpAsmBmpPara, rf, gf, bf)
End Function

' basScale
'
' AUFRUF: basScale(src, tgt, [rf:RotFaktor], _
'                 [gf:GrnFaktor], [bf:BlauFaktor])
'
' EIN:    bar:src Herkunftsdaten (ByteArray)
'         bar:tgt Zieldaten      (ByteArray)
'         lng:rf  red   factor   (default = 71)
'         lng:gf  green factor   (default = 707)
'         bol:bf  blue  factor   (default = 222)
'
' AUS:    log     Erfolg

Function basScale(src() As Byte, tgt() As Byte, _
    Optional rf As Long = 71, _
    Optional gf As Long = 707, _
    Optional bf As Long = 222) As Boolean
    
    Dim X1      As Long
    Dim Y1      As Long
    Dim N1      As Long
    
    For X1 = 1 To UBound(src, 1) Step 4
        For Y1 = 1 To UBound(src, 2)
            
            N1 = (src(X1 + 0, Y1) * _
            rf + src(X1 + 1, Y1) * _
            gf + src(X1 + 2, Y1) * bf) / 1000
            
            If N1 > 255 Then N1 = 255
            
            tgt(X1 + 0, Y1) = N1
            tgt(X1 + 1, Y1) = N1
            tgt(X1 + 2, Y1) = N1
        Next Y1
    Next X1
    
    basScale = True
End Function

